package org.dromara.web.service;

import org.dromara.common.core.domain.R;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.web.domain.bo.BatchProductNuyritionBo;
import org.dromara.web.domain.bo.BatchSuppliesManageBo;
import org.dromara.web.domain.bo.SuppliesManageBo;
import org.dromara.web.domain.vo.SuppliesManageVo;
import org.springframework.web.multipart.MultipartFile;

import java.util.Collection;
import java.util.List;

/**
 * 耗材管理Service接口
 *
 * @author Lion Li
 * @date 2025-07-02
 */
public interface ISuppliesManageService {

    /**
     * 查询耗材管理
     *
     * @param id 主键
     * @return 耗材管理
     */
    SuppliesManageVo queryById(Long id);

    /**
     * 分页查询耗材管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 耗材管理分页列表
     */
    TableDataInfo<SuppliesManageVo> queryPageList(SuppliesManageBo bo, PageQuery pageQuery);

    TableDataInfo<SuppliesManageVo> listAll();

    /**
     * 查询符合条件的耗材管理列表
     *
     * @param bo 查询条件
     * @return 耗材管理列表
     */
    List<SuppliesManageVo> queryList(SuppliesManageBo bo);

    /**
     * 新增耗材管理
     *
     * @param bo 耗材管理
     * @return 是否新增成功
     */
    Boolean insertByBo(SuppliesManageBo bo);

    /**
     * 修改耗材管理
     *
     * @param bo 耗材管理
     * @return 是否修改成功
     */
    Boolean updateByBo(SuppliesManageBo bo);

    /*批量修改 许可证 保质期临期提醒*/
    Boolean batchUpdateSuppliesManage(BatchSuppliesManageBo bo);

    /**
     * 校验并批量删除耗材管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    R<?> importExcel(MultipartFile file) throws Exception;
}
